// Atome.java
// Bruno Bouzy
// 22 janvier 2003

import java.util.*;

class Atome extends Entite {

    public static VectorE mesInstances = new VectorE();
    public Molecule maMolecule;

    public Atome(String n) {
	super(n);
	maMolecule = null;
	mesInstances.addElement(this);
    }

    public void detruire() { mesInstances.removeElement(this); }
  
    public String toString() { return ( "\n" + toNom() + toMolecule()); }

    public String toMolecule() {

	// Question 1: 'Atome.toMolecule'
	// KO:
	// return ("ma molecule: \n" + maMolecule.toNom() + "\n");

	// OK:
	 
        if (maMolecule==null) return ("ma molecule: \n" + "null\n");
	else return ("ma molecule: \n" + maMolecule.toNom() + "\n");
	
    }

    public static void boucle() { while (menu()!='P'); }

    public static char menu() {
	System.out.println( "Atome :");
	System.out.println( "\t C. Creation");
	System.out.println( "\t D. Destruction");
	System.out.println( "\t A. Affichage");
	System.out.println( "\t P. Precedent");
	char r = Keyboard.getChar();
	switch(r) {
	case 'C': creation(); break;
	case 'D': destruction(); break;
	case 'A': System.out.println(mesInstances); break;
	}
	return r;
    }

    public static void creation() {
	System.out.print("\nCreation d'un atome: \n"); 
	System.out.print("\nNom de l'atome ? "); 
	String s = Keyboard.getString();
	Atome a = new Atome(s);
	System.out.println("\nAtome '" + s + "' cree."); 

    }

    public static void destruction() {
	System.out.println("\nDestruction d'un atome: "); 
	System.out.print("\nNom de l'atome ? "); 
	String s = Keyboard.getString();
	Atome  a = (Atome) mesInstances.getInstance(s);
	if (a!=null) {

	    // Question 2: 'Atome.destruction'
	    // KO: rien
	    // OK: cette ligne:
	    if (a.maMolecule!=null) a.maMolecule.mesAtomes.removeElement(a);

	    a.detruire();
	    System.out.println("\nAtome '" + s + "' detruit.");
	}
	else System.out.println("\nPas d'atome portant le nom '" + s + "'.");
    }

    // question 'Molecule.destruction'
    // KO: rien
    // OK: cette fonction:
    
    public static void dereferencer(VectorE va) {
	for (int x=0; x<va.size(); x++) {
	  Atome a = (Atome) va.elementAt(x);
	  a.maMolecule = null;
	}
    }
    
}

